{    var   : }
{ EPSY }
Unit MNB1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MNB1R(N :Integer; var X :Array of Real; var F :Real;
                var EPS :Array of Real; var MAXK :Integer;
                var MKAT :Integer; MCYC :Integer; ALPHA :Real;
                BETA :Real; NSTEP :Integer; var EPSY :Real;
                var X1 :Array of Real; var V :Array of Real;
                var BL :Array of Real; var AL :Array of Real;
                var D :Array of Real; var BLEN :Array of Real;
                var AJ :Array of Real; var E :Array of Real;
                FUN :Proc_F1_MN; var IERR :Integer);

implementation

procedure MNB1R(N :Integer; var X :Array of Real; var F :Real;
                var EPS :Array of Real; var MAXK :Integer;
                var MKAT :Integer; MCYC :Integer; ALPHA :Real;
                BETA :Real; NSTEP :Integer; var EPSY :Real;
                var X1 :Array of Real; var V :Array of Real;
                var BL :Array of Real; var AL :Array of Real;
                var D :Array of Real; var BLEN :Array of Real;
                var AJ :Array of Real; var E :Array of Real;
                FUN :Proc_F1_MN; var IERR :Integer);
var
KAT,II,JJ,K,KK1,I,III,J,JI,KL,KK :Integer;
FBEST,SUMO,SUMN,DIF,SUMAVV,SUMAV :Real;
const
EPSB :Real = 1.0E-10;
label
_110,_120,_130,_140,_150,_160,_170,_180,_190,_210,_220,_230,_240,_250,
_260,_270,_280,_290,_300,_310,_320,_325,_330,_340,_350,_360,_370,_375,
_380,_390,_400,_410,_415,_420,_425,_430,_440;
begin

{ -------POPAMMA EYCOBHO MHMA }
{      METOOM POEHPOKA }
{            APAMETP }
{      N     -PAMEPHOCT POCTPAHCTBA }
{      X     -HA BXOE-HAAHA TOKA OCKA, }
{            HA BX.-OCEH YAHA TOKA }
{      F     -BCEHH MHMYM YHK }
{      EPS   -(BXOHO) HAAH A O }
{            OPTOOHAHM HAPABEHM }
{      MAXK  -HA BXOE MAKCMAHOE, HA BXOE }
{            BOHEHHOE CO BCEHE YHK }
{      MKAT  -HA BXOE MAKCM., HA BXOE }
{            BOHEHHOE CO TAOB }
{      MCYC  -(BX.) MAKCMAHOE CO KOB }
{            HA OHOM TAE METOA }
{      ALPHA,BETA-(BX.) APAMETP METOA }
{      NSTEP -PHAK OHOBEH H AA }
{            (EC NSTEP.EQ.1, TO KA TA }
{            HAHAETC C AA EPS) }
{      EPSY  -AAHHA TOHOCT O YHKOHAY }
{      IERR  -PHAK OKOHAH OCKA }
{      FUN   -POPAMMA BCEH HAEH }
{            EEBO YHK }
{      OCTAHE APAMETP - PAOE MACCB }
{      AOPTMA }
{      K - OPTPAH }
{ -------------------------------------------------- }

KAT := 1;
for II:=1 to N do
 begin
  for JJ:=1 to N do
   begin
    V[(II-1)+(JJ-1)*N] := 0.0;
    if ( II = JJ ) 
     then V[(II-1)+(JJ-1)*N] := 1.0;
_110:
   end;
 end;
FUN(X,SUMO,EPSY);
for K:=1 to N do
 begin
_120:
  X1[K-1] := X[K-1];
 end;
KK1 := 1;
if ( NSTEP = 1 ) 
 then goto _140;
for I:=1 to N do
 begin
_130:
  E[I-1] := EPS[I-1];
 end;

{ *****HAAO TAA. KK1-CETK TAOB }

_140:
FBEST := SUMO;
for I:=1 to N do
 begin
  AJ[I-1] := 2.0;
  if ( NSTEP <> 1 ) 
   then goto _150;
  E[I-1] := EPS[I-1];
_150:
  D[I-1] := 0.0;
 end;
III := 0;

{ *****HAAO KA. III-CETK KOB }

_160:
III := III+1;
_170:
I := 1;
_180:
for J:=1 to N do
 begin
_190:
  X[J-1] := X[J-1]+E[I-1]*V[(I-1)+(J-1)*N];
 end;

{ *****OPAEHE K SUBR. BCEH YHK. }

FUN(X,SUMN,EPSY);
KAT := KAT+1;
_210:
if ( KAT-MAXK ) < 0
 then goto _230
 else if ( KAT-MAXK ) > 0
       then goto _220
       else goto _220;
_220:
IERR := 66;
goto _430;
_230:
if ( SUMN <= SUMO ) 
 then goto _250;
{ *****HEYAH A O HAPABEH E(I) }
for J:=1 to N do
 begin
_240:
  X[J-1] := X[J-1]-E[I-1]*V[(I-1)+(J-1)*N];
 end;
E[I-1] := -BETA*E[I-1];
if ( AJ[I-1] < 1.5 ) 
 then AJ[I-1] := 0.0;
goto _270;
{ *****YAH A O HAPABEH E(I) }
_250:
D[I-1] := D[I-1]+E[I-1];
E[I-1] := ALPHA*E[I-1];
SUMO := SUMN;
for K:=1 to N do
 begin
_260:
  X1[K-1] := X[K-1];
 end;
if ( AJ[I-1] > 1.5 ) 
 then AJ[I-1] := 1.0;
_270:
for J:=1 to N do
 begin
  if ( AJ[J-1] > 0.5 ) 
   then goto _290;
_280:
 end;
goto _320;
_290:
if ( I = N ) 
 then goto _300;
I := I+1;
goto _180;
_300:
for J:=1 to N do
 begin
  JI := Trunc( AJ[J-1]+0.5 );
  if ( JI = 1 ) 
   then goto _170;
_310:
 end;
{ *****AHA O KPTEP CA KOB }
if ( III < MCYC ) 
 then goto _160;
{ *****EPECET OPTOOHAHX HAPABEH }
{     METOOM PAMA-MTA }
_320:
KK1 := KK1+1;
if ( KK1 >= MKAT ) 
 then goto _425;
DIF := FBEST-SUMO;
if ( DIF > EPSY ) 
 then goto _325;
IERR := 0;
goto _430;
_325:
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
_330:
    AL[(I-1)+(J-1)*N] := 0.0;
   end;
 end;
for I:=1 to N do
 begin
  KL := I;
  for J:=1 to N do
   begin
    for K:=KL to N do
     begin
_340:
      AL[(I-1)+(J-1)*N] := D[K-1]*V[(K-1)+(J-1)*N]+AL[(I-1)+(J-1)*N];
     end;
_350:
    BL[(I-1)+(J-1)*N] := AL[(I-1)+(J-1)*N];
   end;
 end;
BLEN[0] := 0.0;
for K:=1 to N do
 begin
  BLEN[0] := BLEN[0]+BL[0+(K-1)*N]*BL[0+(K-1)*N];
_360:
 end;
BLEN[0] := Sqrt(BLEN[0]);
if ( Abs(BLEN[0]) <= EPSB ) 
 then goto _375;
for J:=1 to N do
 begin
_370:
  V[0+(J-1)*N] := BL[0+(J-1)*N]/BLEN[0];
 end;
_375:
for I:=2 to N do
 begin
  II := I-1;
  for J:=1 to N do
   begin
    SUMAVV := 0.0;
    for KK:=1 to II do
     begin
      SUMAV := 0.0;
      for K:=1 to N do
       begin
_380:
        SUMAV := SUMAV+AL[(I-1)+(K-1)*N]*V[(KK-1)+(K-1)*N];
       end;
_390:
      SUMAVV := SUMAV*V[(KK-1)+(J-1)*N]+SUMAVV;
     end;
_400:
    BL[(I-1)+(J-1)*N] := AL[(I-1)+(J-1)*N]-SUMAVV;
   end;
 end;
for I:=2 to N do
 begin
  BLEN[I-1] := 0.0;
  for K:=1 to N do
   begin
_410:
    BLEN[I-1] := BLEN[I-1]+BL[(I-1)+(K-1)*N]*BL[(I-1)+(K-1)*N];
   end;
  BLEN[I-1] := Sqrt(BLEN[I-1]);
  if ( Abs(BLEN[I-1]) <= EPSB ) 
   then goto _420;
  for J:=1 to N do
   begin
_415:
    V[(I-1)+(J-1)*N] := BL[(I-1)+(J-1)*N]/BLEN[I-1];
   end;
_420:
 end;
goto _140;
{ ****BXO  OPOPAMM }
_425:
IERR := 68;
_430:
for I:=1 to N do
 begin
_440:
  X[I-1] := X1[I-1];
 end;
MKAT := KK1;
MAXK := KAT;
F := SUMO;
end;

end.
